SystemOrganization addCategory: #'XPF-CodeMarker'!
SystemOrganization addCategory: #'XPF-Tests-Models'!
SystemOrganization addCategory: #'XPF-Models'!
SystemOrganization addCategory: #'XPF-Seaside-Components'!
SystemOrganization addCategory: #'XPF-Seaside-ComponentsTest'!

!String methodsFor: '*XPF-CodeMarker' stamp: 'mt 1/20/2009 17:17'!!
findAllStrings: aString
	"Returns a collection with all starting indices of the given string in me."
	
	|indices currentStartIndex|
	indices := Bag new.
	currentStartIndex := 1.
	
	[currentStartIndex := (self findString: aString startingAt: currentStartIndex) + 1.
		currentStartIndex > 1 
	] whileTrue: [indices add: currentStartIndex - 1].

	^indices.! !

!OBCmdMultiView methodsFor: '*XPF-CodeMarker' stamp: 'mt 1/22/2009 18:19'!!
execute
	|viewType|
	viewType := OBChoiceRequest labels: #(Source Bytecode Decompile PrettyPrint XPF).
	self styler: SHTextStylerST80 new.
	viewType ifNotNil: [self perform: (#toggle, viewType) asSymbol]! !

!OBCmdMultiView methodsFor: '*XPF-CodeMarker' stamp: 'cs 1/15/2009 17:24'!!
styler: styler
	| panel morph |
	
	panel := requestor browser panels 
		detect: [ :each | each isKindOf: OBDefinitionPanel ]
		ifNone: [ ^ self ].
	morph := OBPluggableTextMorph allSubInstances
		detect: [ :each | each model == panel ]
		ifNone: [ ^ self ].
	morph styler: (styler
		view: morph;
		yourself).! !

!OBCmdMultiView methodsFor: '*XPF-CodeMarker' stamp: 'cs 1/15/2009 17:22'!!
toggleXPF

	self styler: XPFTextStyler new.
	self setTextInDefinitionPanel: target source.! !

TestCase subclass: #XPFTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-Tests-Models'!

XPFTestCase subclass: #XPFTaskTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-Tests-Models'!

!XPFTaskTest methodsFor: 'as yet unclassified' stamp: 'mig 1/23/2009 13:31'!!
testNewAndDelete
	| task oldCount |
	
	oldCount := XPFTask all size.
	
	task := XPFTask addNew: [ :newTask | 
		newTask
			taskName: 'test task';
			taskDescription: 'this is a test task' ;
			yourself].
		
	self should: XPFTask all size = (oldCount + 1).
	self should: (XPFTask all anySatisfy: [ :each | each taskName = 'test task' ]).
	
	XPFTask delete: task.
	
	self should: XPFTask all size = oldCount.! !

!XPFTestCase class methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 11:46'!!
isAbstract
 	^self name = #XPFTestCase! !

!XPFTestCase methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 11:34'!!
checkAccessor: aSelector on: aTargetObject with: anObject
	"test getter/setter aSelector of aTargetObject with anObject"
	
	aTargetObject perform: aSelector asMutator with: anObject.
	self
		assert: (aTargetObject perform: aSelector) == anObject
		! !

XPFTestCase subclass: #XPFUserStoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-Tests-Models'!

!XPFUserStoryTest methodsFor: 'tests' stamp: 'mig 1/23/2009 12:02'!!
testAttributes
	| us |
	us := XPFUserStory new.
	self
		checkAccessor: #storyName on: us with: 'US + Tasks verwalten';
		checkAccessor: #storyDescription on: us with: 'Dinge tun und Sachen machen';
		checkAccessor: #storyPriority on: us with: 5;
		checkAccessor: #storyEstimate on: us  with: 10;
		checkAccessor: #storyActual on: us  with: 12.
! !

!XPFUserStoryTest methodsFor: 'tests' stamp: 'mig 1/23/2009 12:26'!!
testNewAndDelete
	| userStory oldCount |
	
	oldCount := XPFUserStory all size.
	
	userStory := XPFUserStory addNew: [ :newUserStory | 
		newUserStory
			storyName: 'test story';
			storyDescription: 'this is a test story';
			storyPriority: 3;
			storyEstimate: 10 ].
		
	self should: XPFUserStory all size = (oldCount + 1).
	self should: (XPFUserStory all anySatisfy: [ :each | each storyName = 'test story' ]).
	
	XPFUserStory delete: userStory.
	
	self should: XPFUserStory all size = oldCount.
	! !

OBTextMorphEditorWithShout subclass: #XPFEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-CodeMarker'!

!XPFEditor class methodsFor: 'as yet unclassified' stamp: 'mt 1/23/2009 14:45'!!
initializeCmdKeyShortcuts
	super initializeCmdKeyShortcuts.
	CmdActions
		at: ($q asInteger + 1) put: #markAsGood:;
		at: ($r asInteger + 1) put: #markAsBad:;
		at: ($t asInteger + 1) put: #markAsUnknown:.
	
! !

!XPFEditor methodsFor: 'as yet unclassified' stamp: 'mt 1/23/2009 14:43'!!
markAsBad: aCharacterStream
	paragraph setBackgroundForSelectionWith: Color red.
	self userHasEdited.
	^ true

	
! !

!XPFEditor methodsFor: 'as yet unclassified' stamp: 'mt 1/23/2009 14:44'!!
markAsGood: aCharacterStream
	paragraph setBackgroundForSelectionWith: Color green.
	self userHasEdited.
	^ true
	
! !

!XPFEditor methodsFor: 'as yet unclassified' stamp: 'mt 1/23/2009 14:43'!!
markAsUnknown: aCharacterStream
	paragraph setBackgroundForSelectionWith: Color lightGray.
	self userHasEdited.
	^ true
	
! !

!XPFEditor methodsFor: 'as yet unclassified' stamp: 'mt 1/23/2009 11:05'!!
readKeyboard
	super readKeyboard.! !

!XPFEditor methodsFor: 'as yet unclassified' stamp: 'mt 1/23/2009 15:13'!!
save: characterStream
"	self haltOnce."
	Transcript show: 'blubb'.
	^super save: characterStream.! !

!XPFEditor methodsFor: 'as yet unclassified' stamp: 'mt 1/23/2009 11:20'!!
setEmphasisHere
	emphasisHere := (paragraph text attributesAt: (self pointIndex - 1 max: 1) forStyle: paragraph textStyle)
					select: [:att | att mayBeExtended]! !

OBTextMorphWithShout subclass: #XPFTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-CodeMarker'!

!XPFTextMorph methodsFor: 'as yet unclassified' stamp: 'mt 1/23/2009 11:00'!!
editorClass
	"Answer the class used to create the receiver's editor"
	
	^XPFEditor! !

Object subclass: #XPFTask
	instanceVariableNames: 'taskName taskDescription'
	classVariableNames: 'Tasks'
	poolDictionaries: ''
	category: 'XPF-Models'!

!XPFTask class methodsFor: 'manipulation' stamp: 'mig 1/23/2009 13:52'!!
addNew: aBlock
	| task |
	task := aBlock value: self new.
	task ifNotNil: [self all add: task].
	^ task! !

!XPFTask class methodsFor: 'manipulation' stamp: 'mig 1/23/2009 13:51'!!
all
	Tasks isNil
		ifTrue: [Tasks := OrderedCollection new].
	^Tasks! !

!XPFTask class methodsFor: 'manipulation' stamp: 'mig 1/23/2009 13:53'!!
delete: aTask

	^ self all remove: aTask! !

!XPFTask class methodsFor: 'description' stamp: 'mig 1/23/2009 13:54'!!
descriptionDescription
	^MAMemoDescription new
		selectorAccessor: #taskDescription;
		label: 'Description';
		priority: 20;
		yourself! !

!XPFTask class methodsFor: 'description' stamp: 'mig 1/23/2009 13:54'!!
descriptionName
	^MAStringDescription new
		selectorAccessor: #taskName;
		label: 'Name';
		priority: 10;
		default: 'New Task';
		yourself! !

!XPFTask methodsFor: 'accessing' stamp: 'mig 1/23/2009 13:49'!!
descriptionReport
	^super description 
		select: [:each | #(taskName taskDescription) includes: each accessor selector]! !

!XPFTask methodsFor: 'accessing' stamp: 'mig 1/23/2009 13:48'!!
taskDescription
	^ taskDescription! !

!XPFTask methodsFor: 'accessing' stamp: 'mig 1/23/2009 13:48'!!
taskDescription: anObject
	taskDescription := anObject! !

!XPFTask methodsFor: 'accessing' stamp: 'mig 1/23/2009 13:48'!!
taskName
	^ taskName! !

!XPFTask methodsFor: 'accessing' stamp: 'mig 1/23/2009 13:48'!!
taskName: anObject
	taskName := anObject! !

Object subclass: #XPFUserStory
	instanceVariableNames: 'storyName storyDescription storyPriority storyEstimate storyActual'
	classVariableNames: 'UserStories'
	poolDictionaries: ''
	category: 'XPF-Models'!

!XPFUserStory class methodsFor: 'manipulation' stamp: 'mig 1/23/2009 12:31'!!
addNew: aBlock
	| userStory |
	userStory := aBlock value: self new.
	userStory ifNotNil: [self all add: userStory].
	^ userStory.! !

!XPFUserStory class methodsFor: 'manipulation' stamp: 'mig 1/23/2009 12:10'!!
all
	(UserStories isNil)
		ifTrue: [UserStories := OrderedCollection new].

	^UserStories! !

!XPFUserStory class methodsFor: 'manipulation' stamp: 'mig 1/23/2009 12:25'!!
delete: userStory
	self all remove: userStory! !

!XPFUserStory class methodsFor: 'description' stamp: 'SR 1/22/2009 15:08'!!
descriptionActual
	^MANumberDescription new
		selectorAccessor: #storyActual;
		label: 'Actual';
		priority: 40;
		default: 0;
		yourself! !

!XPFUserStory class methodsFor: 'description' stamp: 'SR 1/22/2009 15:08'!!
descriptionDescription
	^MAMemoDescription new
		selectorAccessor: #storyDescription;
		label: 'Description';
		priority: 20;
		yourself! !

!XPFUserStory class methodsFor: 'description' stamp: 'SR 1/22/2009 15:08'!!
descriptionEstimate
	^MANumberDescription new
		selectorAccessor: #storyEstimate;
		label: 'Estimate';
		priority: 40;
		default: 0;
		yourself! !

!XPFUserStory class methodsFor: 'description' stamp: 'SR 1/22/2009 15:08'!!
descriptionName
	^MAStringDescription new
		selectorAccessor: #storyName;
		label: 'Name';
		priority: 10;
		default: 'New User Story';
		yourself! !

!XPFUserStory class methodsFor: 'manipulation' stamp: 'SR 1/22/2009 15:07'!!
descriptionPriority
	^MANumberDescription new
		selectorAccessor: #storyPriority;
		label: 'Priority';
		priority: 30;
		default: 3;
		yourself! !

!XPFUserStory methodsFor: 'description' stamp: 'SR 1/22/2009 15:12'!!
descriptionReport
	^super description 
		select: [:each | #(storyName storyEstimate storyPriority) includes: each accessor selector]! !

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:04'!!
storyActual
	^ storyActual! !

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:04'!!
storyActual: anObject
	storyActual := anObject! !

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:05'!!
storyDescription
	^ storyDescription! !

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:05'!!
storyDescription: anObject
	storyDescription := anObject! !

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:05'!!
storyEstimate
	^ storyEstimate! !

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:05'!!
storyEstimate: anObject
	storyEstimate := anObject! !

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:05'!!
storyName
	^ storyName! !

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:05'!!
storyName: anObject
	storyName := anObject! !

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:05'!!
storyPriority
	^ storyPriority! !

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:05'!!
storyPriority: anObject
	storyPriority := anObject! !

!OBPluggableTextMorphWithShout methodsFor: '*XPF-CodeMarker' stamp: 'mt 1/22/2009 16:59'!!
textMorphClass
	"Answer the class used to create the receiver's textMorph"
	^XPFTextMorph! !

WAComponent subclass: #XPFRootComponent
	instanceVariableNames: 'userStoryAdmin taskAdmin navigation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-Seaside-Components'!

!XPFRootComponent class methodsFor: 'as yet unclassified' stamp: 'mig 1/23/2009 13:58'!!
canBeRoot
	^ true! !

!XPFRootComponent methodsFor: 'rendering' stamp: 'topa 1/23/2009 15:10'!!
children
	^ Array with: self navigation! !

!XPFRootComponent methodsFor: 'initialize-release' stamp: 'topa 1/23/2009 15:09'!!
initialize
	super initialize.
	self
		userStoryAdmin: XPFUserStoryComponent new;
		taskAdmin: XPFTaskComponent new;
		initializeNavigation! !

!XPFRootComponent methodsFor: 'initialize-release' stamp: 'topa 1/23/2009 15:12'!!
initializeNavigation
	self navigation: WASimpleNavigation new.
	(self navigation)
		add: self userStoryAdmin label: 'User Stories';
		add: self taskAdmin label: 'Tasks';
		select: self navigation options first! !

!XPFRootComponent methodsFor: 'accessing' stamp: 'topa 1/23/2009 15:10'!!
navigation
	^ navigation! !

!XPFRootComponent methodsFor: 'accessing' stamp: 'topa 1/23/2009 15:12'!!
navigation: anObject 
	navigation := anObject! !

!XPFRootComponent methodsFor: 'accessing' stamp: 'mig 1/23/2009 14:16'!!
taskAdmin
	^ taskAdmin! !

!XPFRootComponent methodsFor: 'accessing' stamp: 'mig 1/23/2009 14:16'!!
taskAdmin: anObject
	taskAdmin := anObject! !

!XPFRootComponent methodsFor: 'accessing' stamp: 'mig 1/23/2009 14:04'!!
userStoryAdmin
	^ userStoryAdmin! !

!XPFRootComponent methodsFor: 'accessing' stamp: 'mig 1/23/2009 14:04'!!
userStoryAdmin: anObject
	userStoryAdmin := anObject! !

WAComponent subclass: #XPFTaskComponent
	instanceVariableNames: 'report'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-Seaside-Components'!

!XPFTaskComponent class methodsFor: 'as yet unclassified' stamp: 'mig 1/23/2009 14:06'!!
canBeRoot
	^ false! !

!XPFTaskComponent methodsFor: 'accessing' stamp: 'mig 1/23/2009 14:14'!!
children
	^ Array with: report! !

!XPFTaskComponent methodsFor: 'actions' stamp: 'mig 1/23/2009 14:17'!!
createNewTask

	XPFTask addNew: [:newTask |
		self call: newTask asComponent addValidatedForm ].
	self refreshReport.! !

!XPFTaskComponent methodsFor: 'actions' stamp: 'mig 1/23/2009 14:30'!!
deleteTask: aTask

	(self confirm: ('Do you really want to delete the task named "{1}"?' format: {aTask taskName}))
		ifTrue: [XPFTask delete: aTask. self refreshReport.].! !

!XPFTaskComponent methodsFor: 'actions' stamp: 'mig 1/23/2009 14:13'!!
editTask: aTask
	(self call: (aTask description asComponentOn: aTask) addValidatedForm)
		ifNotNil: [self refreshReport].! !

!XPFTaskComponent methodsFor: 'initialize-release' stamp: 'mig 1/23/2009 14:07'!!
initialize
	super initialize.
	self initializeReport.! !

!XPFTaskComponent methodsFor: 'initialize-release' stamp: 'mig 1/23/2009 14:09'!!
initializeReport
	self report: (MAReport
 		rows: XPFTask all
 		description: XPFTask new descriptionReport).
		
	self report
		addColumn: (MACommandColumn new
			addCommandOn: self selector: #editTask: text: 'edit';
			yourself);
		addColumn: (MACommandColumn new
			addCommandOn: self selector: #deleteTask: text: 'delete';
			yourself).! !

!XPFTaskComponent methodsFor: 'updating' stamp: 'mig 1/23/2009 14:13'!!
refreshReport
	self report rows: XPFTask all.! !

!XPFTaskComponent methodsFor: 'rendering' stamp: 'mig 1/23/2009 14:41'!!
renderContentOn: html
	html div with: [
		html div 
			with: self report.
		html anchor 
			callback: [self createNewTask]; 
			with: 'Add Task'. ]! !

!XPFTaskComponent methodsFor: 'accessing' stamp: 'mig 1/23/2009 14:06'!!
report
	^ report! !

!XPFTaskComponent methodsFor: 'accessing' stamp: 'mig 1/23/2009 14:06'!!
report: anObject
	report := anObject! !

WAComponent subclass: #XPFUserStoryComponent
	instanceVariableNames: 'report'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-Seaside-Components'!

!XPFUserStoryComponent class methodsFor: 'as yet unclassified' stamp: 'mig 1/23/2009 13:58'!!
canBeRoot
	^false! !

!XPFUserStoryComponent methodsFor: 'accessing' stamp: 'SR 1/22/2009 14:44'!!
children
	^Array with: self report.! !

!XPFUserStoryComponent methodsFor: 'as yet unclassified' stamp: 'mig 1/23/2009 12:31'!!
createNewUserStory

	XPFUserStory addNew: [:newUserStory |
		self call: newUserStory asComponent addValidatedForm ].
	self refreshReport.
! !

!XPFUserStoryComponent methodsFor: 'as yet unclassified' stamp: 'mig 1/23/2009 14:32'!!
deleteUserStory: aUserStory

	(self confirm: ('Do you really want to delete the user story named "{1}"?' format: {aUserStory storyName})) ifTrue: [
		XPFUserStory delete: aUserStory. self refreshReport ]! !

!XPFUserStoryComponent methodsFor: 'as yet unclassified' stamp: 'mig 1/23/2009 12:32'!!
editUserStory: aUserStory
	(self call: (aUserStory description asComponentOn: aUserStory) addValidatedForm)
		ifNotNil: [self refreshReport].! !

!XPFUserStoryComponent methodsFor: 'initialization' stamp: 'SR 1/22/2009 14:33'!!
initialize
	super initialize.
	self initializeReport.! !

!XPFUserStoryComponent methodsFor: 'initialization' stamp: 'mig 1/23/2009 12:32'!!
initializeReport
	self report: (MAReport
 		rows: XPFUserStory all
 		description: XPFUserStory new descriptionReport).
		
	self report
		addColumn: (MACommandColumn new
			addCommandOn: self selector: #editUserStory: text: 'edit';
			yourself);
		addColumn: (MACommandColumn new
			addCommandOn: self selector: #deleteUserStory: text: 'delete';
			yourself).! !

!XPFUserStoryComponent methodsFor: 'as yet unclassified' stamp: 'mig 1/23/2009 12:32'!!
refreshReport
	self report rows: (XPFUserStory all).! !

!XPFUserStoryComponent methodsFor: 'rendering' stamp: 'mig 1/23/2009 14:41'!!
renderContentOn: html
	html div with: [
		html div 
			with: self report.
		html anchor 
			callback: [self createNewUserStory]; 
			with: 'Add User Story'. ]! !

!XPFUserStoryComponent methodsFor: 'accessing' stamp: 'SR 1/22/2009 14:45'!!
report
	^ report! !

!XPFUserStoryComponent methodsFor: 'accessing' stamp: 'SR 1/22/2009 14:45'!!
report: anObject
	report := anObject! !

!MultiNewParagraph methodsFor: '*XPF-CodeMarker' stamp: 'mt 1/22/2009 16:27'!!
displayOn: aCanvas using: displayScanner at: somePosition 
	"Send all visible lines to the displayScanner for display"
	| visibleRectangle offset leftInRun line |
	visibleRectangle := aCanvas clipRect.
	offset := somePosition - positionWhenComposed.
	leftInRun := 0.
	(self lineIndexForPoint: visibleRectangle topLeft) 
		to: (self lineIndexForPoint: visibleRectangle bottomRight)
		do: 
			[ :i | 
			line := lines at: i.
			self
				drawBackgroundOn: aCanvas
					at: line;
				displaySelectionInLine: line
					on: aCanvas.
			line first <= line last ifTrue: 
				[ leftInRun := displayScanner 
					displayLine: line
					offset: offset
					leftInRun: leftInRun ] ]! !

!MultiNewParagraph methodsFor: '*XPF-CodeMarker' stamp: 'mt 1/22/2009 16:27'!!
drawBackgroundOn: aCanvas at: line 
	| cb1 cb2 textLine bgAttr |
	textLine := self text 
		copyFrom: line first
		to: line last.
	textLine runs withStartStopAndValueDo: 
		[ :start :stop :attributes | 
		bgAttr := attributes 
			detect: [ :each | each isMemberOf: XPFTextBackgroundColor ]
			ifNone: [  ].
		bgAttr ifNotNil: 
			[ cb1 := self characterBlockForIndex: start + (line first - 1).
			cb2 := self characterBlockForIndex: stop + (line first - 1).
			aCanvas 
				fillRectangle: (cb1 left @ line top corner: cb2 right @ line bottom)
				color: bgAttr color ] ]! !

!MultiNewParagraph methodsFor: '*XPF-CodeMarker' stamp: 'mt 1/22/2009 17:24'!!
setBackgroundForSelectionWith: aColor
	selectionStart stringIndex == selectionStop ifTrue: [^nil].
	self text addAttribute: (XPFTextBackgroundColor new color: aColor; yourself) from: selectionStart stringIndex to: selectionStop stringIndex - 1! !

SHTextStylerST80 subclass: #XPFTextStyler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-CodeMarker'!

!XPFTextStyler methodsFor: 'private' stamp: 'mt 1/23/2009 15:46'!!
privateFormat: aText
	^super privateFormat: aText.! !

!XPFTextStyler methodsFor: 'private' stamp: 'mt 1/23/2009 15:22'!!
privateStyle: aText
	"First, backup current style information about background color in text runs. Then let Shout work. Then restore background color information for text runs."

	| backupRuns |
	backupRuns := aText runs.

	super privateStyle: aText.
	
	backupRuns withStartStopAndValueDo: [:start :stop :attrs | |a|
		a := attrs detect: [:attr | attr isKindOf: XPFTextBackgroundColor] ifNone: [nil].
		a ifNotNil: [aText addAttribute: a from: start to: stop].
	]! !

!XPFTextStyler methodsFor: 'as yet unclassified' stamp: 'mt 1/23/2009 15:24'!!
unstyledTextFrom: aText

	| backupRuns result |
	backupRuns := aText runs.

	result := super unstyledTextFrom: aText.
	
	backupRuns withStartStopAndValueDo: [:start :stop :attrs | |a|
		a := attrs detect: [:attr | attr isKindOf: XPFTextBackgroundColor] ifNone: [nil].
		a ifNotNil: [result addAttribute: a from: start to: stop].
	].

	^result.! !

TextAttribute subclass: #XPFTextBackgroundColor
	instanceVariableNames: 'color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-CodeMarker'!

!XPFTextBackgroundColor methodsFor: 'comparing' stamp: 'mt 1/22/2009 11:23'!!
= other 
	^ (other class == self class) 
		and: [other color = color]! !

!XPFTextBackgroundColor methodsFor: 'html' stamp: 'mt 1/22/2009 11:24'!!
closeHtmlOn: aStream 
	"put on the given stream the tag to close the html  
	representation of the receiver"
	aStream nextPutAll: '</span>'! !

!XPFTextBackgroundColor methodsFor: 'accessing' stamp: 'mt 1/22/2009 11:22'!!
color
	^ color! !

!XPFTextBackgroundColor methodsFor: 'accessing' stamp: 'mt 1/22/2009 17:51'!!
color: aColor
	color := aColor copy alpha: 0.4.! !

!XPFTextBackgroundColor methodsFor: 'scanning' stamp: 'mt 1/22/2009 11:26'!!
dominates: other
	^ other class == self class! !

!XPFTextBackgroundColor methodsFor: 'comparing' stamp: 'mt 1/22/2009 11:23'!!
hash
	^ color hash! !

!XPFTextBackgroundColor methodsFor: 'html' stamp: 'mt 1/22/2009 11:25'!!
openHtmlOn: aStream 
	"put on the given stream the tag to open the html  
	representation of the receiver"
	aStream nextPutAll: '<span style="background-color: #' , color printHtmlString , '">'! !

!XPFTextBackgroundColor methodsFor: 'printing' stamp: 'mt 1/22/2009 11:25'!!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' code: '; print: color! !

!XPFTextBackgroundColor methodsFor: 'scanning' stamp: 'mt 1/22/2009 11:27'!!
writeScanOn: strm
	"Two formats.  c125000255 or cblue;"

	| nn str |
	strm nextPut: $h. "h ... highlight"
	(nn := color name) ifNotNil: [
		(self class respondsTo: nn) ifTrue: [
			^ strm nextPutAll: nn; nextPut: $;]].
	(Array with: color red with: color green with: color blue) do: [:float |
		str := '000', (float * 255) asInteger printString.
		strm nextPutAll: (str copyFrom: str size-2 to: str size)]! !
